create or replace function test_heap_update(logsize integer, fillersize int4, hot boolean)
returns void language plpgsql as
$$
declare
  beginwal pg_lsn;
  endwal pg_lsn;
  begintime timestamp;
  endtime timestamp;
  operations integer;
  colsize int4;
begin
  create table testtbl(filler text) with (fillfactor=10);
  insert into testtbl select repeat('x', fillersize) from generate_series(1, 50000) g;

  operations = 0;
  beginwal = pg_current_xlog_insert_location();
  begintime = clock_timestamp();
  loop
    operations = operations + 100000;

    update testtbl set filler = repeat('y', fillersize);    
    update testtbl set filler = repeat('x', fillersize);    

    endwal = pg_current_xlog_insert_location();
    exit when endwal - beginwal >= logsize;
  end loop;
  endtime = clock_timestamp();
  endwal = pg_current_xlog_insert_location();

  select pg_column_size(testtbl) into colsize from testtbl limit 1;
  insert into testresult (wal, description, operations, dur_s)
    values (
      endwal - beginwal,
      case when hot then 'hot' else 'heap' end || ' update ' || colsize,
      operations,
      extract(epoch from endtime - begintime)
    );

  -- clean up
  drop table testtbl;
end;
$$;
